# Contributing to DSDIN

### Pull Requests

* [Squash your commits](https://stackoverflow.com/questions/5189560/squash-my-last-x-commits-together-using-git) to ensure each resulting commit is stable and can be tested.
* Include issue numbers in the PR title, e.g. "GH-128. Resolves issue #123".
* Follow the [Erlang mode for Emacs](http://erlang.org/doc/apps/tools/erlang_mode_chapter.html) indentation, e.g. provided by [EDTS](https://github.com/tjarvstrand/edts).
* Add unit tests for self-contained modules.
* Add integration tests as needed.
* Document new code.
* End all files with a newline

### Git Commit Messages

* Use the present tense ("Add feature" not "Added feature")
* Use the imperative mood ("Move cursor to..." not "Moves cursor to...")
* Limit the first line to 72 characters or less
* Reference issues and pull requests liberally after the first line

Learn more about [writing a good commit message](https://chris.beams.io/posts/git-commit/).
